/*! \file dngutils.h
 *  \brief Interfaces publicos de la libreria de utilidades.
 *         Libreria de Dingoo.
 *
 *  \version 0.9
 *
 *  Dingoo Utilities driver
 *
 *   Pituka - Dingoo Port
 *  (c) Copyright 2009 David Colmenero (aka D_Skywalk)
 */

#ifndef u_utilx_h
#define u_utilx_h

void *ultra_memcpy(void *dest, const void *src, size_t count);
void bitmap_scale(int viswidth, int visheight, unsigned short *bmpline);


/** \brief Estructura de Imagenes
 *  Esta es una estructura general que contiene las imagenes del emulador y usarlas para el render en Wii.
 * \note Solo soporta PNG.
 */
typedef struct{
  void * buffer; /**< El buffer que contiene la Textura usable por Dingoo */

  int Width; /**< ancho de la imagen */
  int Height; /**< alto de la imagen */
} t_img;


void InitImg (t_img * img);
void FreeImg (t_img * img);

bool LoadBitmap (t_img * img, const unsigned char my_png[]);
void DrawBitmap (t_img * img, int y);

#endif
